import appuifw
from graphics import *

class eAppUIfw:
	def __init__(self, ecb):
		appuifw.app.screen='full'
		self.canvas = appuifw.app.body = appuifw.Canvas(event_callback=ecb, redraw_callback=self.draw)
		self._canvas = Image.new(self.canvas.size, 'RGB16')
		self._avatar = None

	def draw(self, env=None):
		try: self._avatar, horde, scenery, pulse = env
		except: pass
		#~ except: e32.ao_yield() # Dunno what that means

		if self._avatar:
			if scenery: self._canvas.blit(scenery.img)
			else: self._canvas.clear(0)
			av = self._avatar # shortcut
			av._update(pulse=pulse%5) # can only be called on AC and AAC

			# Debug box
			#~ data=u'vx:%s vy:%s a:%s'%(round(av.vel[0],1), round(av.vel[1],1), av.alt)
			#~ textrect=self._canvas.measure_text(data, font='normal')[0]
			#~ text_img=Image.new((textrect[2]-textrect[0],textrect[3]-textrect[1]))
			#~ text_img.clear(0)
			#~ text_img.text((-textrect[0],-textrect[1]),data,fill=0xffffff,font='normal')
			#~ self._canvas.blit(text_img)

			self._canvas.blit(av.img, target=av.loc, mask=av.msk)
			self.canvas.blit(self._canvas)

	def shot(self):
		self._canvas.save(u'E:\\Images\\freed0m.png')
